package edu.sc.seis.cormorant.event;

import org.omg.PortableServer.POA;
import org.omg.PortableServer.Servant;
import org.omg.PortableServer.ServantLocatorPackage.CookieHolder;

import edu.iris.Fissures.IfEvent.EventAccessPOATie;
import edu.iris.Fissures.IfEvent.EventAttr;
import edu.iris.Fissures.IfEvent.NoPreferredOrigin;
import edu.iris.Fissures.IfEvent.Origin;
import edu.iris.Fissures.event.OriginImpl;
import edu.sc.seis.fissuresUtil.cache.CacheEvent;
import edu.sc.seis.fissuresUtil.database.NotFound;
import edu.sc.seis.fissuresUtil.hibernate.EventDB;

class EventLocator_impl extends org.omg.PortableServer.ServantLocatorPOA {

    public EventLocator_impl(EventDataAccess eventAccess, POA poa) {
        this.jdbcEventAccess = eventAccess;
        this.poa = poa;
        System.out.println("EventLocator: EventDataAccess class = " + eventAccess.getClass());
    }

    public Servant preinvoke(byte[] oid, POA inPoa, String op, CookieHolder cookie) {
        String oid_string = new String(oid);
        logger.debug("oid_string = " + oid_string);
        try {
            if (oid_string.indexOf("EventAccessImpl") != -1) {
                logger.debug("The type of the object is EventAccess " + op);
                CacheEvent ce = jdbcEventAccess.getEvent(Integer.parseInt(oid_string));
                return new EventAccessPOATie(ce);
            } else {
                CacheEvent ce = jdbcEventAccess.getEvent(Integer.parseInt(oid_string));
                EventAttr attr = ce.get_attributes();
                if (attr == null) {
                    logger.error("Attr is null for "+oid_string);
                }
                try {
                    OriginImpl o = (OriginImpl)ce.get_preferred_origin();
                    o.get_id();
                    logger.debug("Got event("+oid_string+") at "+ce.get_preferred_origin().getOriginTime().date_time);
                } catch(NoPreferredOrigin e) {
                    throw new org.omg.CORBA.UNKNOWN("no preferred origin");
                }
                ce.getOrigins();
                return new EventAccessPOATie(ce);
            }
        } catch(NotFound e) {
            logger.warn("Did not find event for dbid=" + oid_string, e);
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        } catch(Throwable e) {
            logger.warn("Problem finding event for dbid=" + oid_string, e);
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();
        }
    }

    public void postinvoke(byte[] oid, POA inPoa, String operation, Object cookie, Servant servant) {}

    protected EventDataAccess jdbcEventAccess;

    POA poa;

    private static final org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(EventLocator_impl.class);
}